PRO sample_GSMaP_NetCDF_IDL
  
  fnL3 = '../../data_07A/GPMMRG_MAP_2112010000_H_L3S_MCN_05A.nc'
  print, ' '
  print, '+ Input file name +'
  print, fnL3

;Read Dataset Sample
;   fileID    = H5F_OPEN(fnL3)

;   dataSetName  = '/Grid/hourlyPrecipRateGC'
;   dataSetID    = H5D_OPEN(fileID, dataSetName )
;   rain_data    = H5D_READ(dataSetID)
;   H5D_CLOSE, dataSetID  

;   H5F_CLOSE, fileID

;Read Dataset Sample with netcdf
  fileID    = NCDF_OPEN(fnL3)

  dataSetName  = 'hourlyPrecipRateGC'
  dataSetID    = NCDF_VARID(fileID, dataSetName )
  NCDF_VARGET, fileID, dataSetID, rain_data 

  NCDF_CLOSE, fileID

;+++ rotate GSMaP data
rain_data = rotate(rain_data,4)

;+++ convert 1byte scale data for drawing
rain_byte = bytarr(3600,1800)

tdb_rain   = [0,0.1,  0.5, 1,   2,   3,   5,   10,  15,  20,  25,  1000] ; [mm/h]
tdb_r_elem = [255,   0,   0,   0,  51, 155, 255, 255, 255, 235, 175 ]
tdb_g_elem = [255,   0, 100, 180, 219, 235, 235, 179, 100,  30,   0 ]
tdb_b_elem = [255, 150, 250, 250, 128,  74,   0,   0,   0,   0,   0 ]

num_size = size(tdb_r_elem)
num = num_size(1)

for i=0L, num - 1L do begin
 w = where( (tdb_rain[i] le rain_data) and (rain_data lt tdb_rain[i+1L]), cw )
 if (cw ge 1) then begin
  rain_byte(w) = i
 endif
endfor ; i

;+++ set color 
device,retain=2,decomposed=0

tvlct, r, g, b, /get
r[0:num-1L] = tdb_r_elem[*]
g[0:num-1L] = tdb_g_elem[*]
b[0:num-1L] = tdb_b_elem[*]
r[255]=0 & g[255]=0 & b[255]=0
tvlct, r, g, b

;+++ draw on map
window, 1, xsize=800, ysize=400, title='GSMaP_HDF5'

MAP_SET, 0, 0, /CYLINDRICAL,  $
   LIMIT=[-60, -180, 60, 180], pos=[0.1, 0.1, 0.9, 0.9], $
   /noerase
;   /noerase, /NOBORDER

result = MAP_IMAGE(rain_byte, x0, y0, xsize, ysize, $ 
;   COMPRESS=1, SCALE=0.01, $
   COMPRESS=1, $
   LATMIN=-90, LONMIN=-180, $
   LATMAX=90, LONMAX=180)

TV, result, x0, y0, xsize=xsize, ysize=ysize

map_continents
map_grid, LABEL=1, CHARSIZE=1.0, GLINESTYLE=1, $
          LATLAB=-15, LONLAB=-45, $
          LONDEL=30, LATDEL=10, /BOX_AXES

write_png,'sample_GSMaP_NetCDF_IDL.png',tvrd(/true)

END
